'''
This code is part of NightmareTyrant; Copyright (C) 2013 Piotr 'ZasVid' Sikora; see NightmareTyrant.py for full notice.
'''

from guts.messages import message, infotip
from guts.game_data import game

def feedback_msg(action, agent):
    #TODO: differentiate between player and other agent's, fov
    message(*action['msg'])
    #message(action['msg'])

def mission(action, agent):
    #TODO: check if objective available
    if agent.is_player():
        if action['accomplished']:
            message(action['done msg'])
        else:
            message(action['msg'])
            game.current_quest.accomplish(action['objective'])
            action['accomplished'] = True
            if 'done color' in action:
                action.piece.color = action['done color']
            if 'done shape' in action:
                action.piece.color = action['done shape']


def replenish(interaction, agent):
    """ Replenish the value of a trait (such as health, shields or ammo) without going over its max value """
    trait, amount = interaction['trait'], interaction['amount']
    if agent[trait] == agent['max ' + trait]:
        if agent.is_player():
            infotip("You're at full " + trait + " already!", trait)
        return False
    else:
        agent[trait] += amount
        if agent[trait] > agent['max ' + trait]:
            agent[trait] = agent['max ' + trait]    
        if agent.is_player():
            message("You replenish your " + trait + " by " + str(amount) + ".", trait)
        else:
            message(agent.name +" replenishes its " + trait + " by " + str(amount) + ".", trait)
        return True

def door_manipulation(interaction, agent):
    """
    """
    piece = interaction.piece
    flags = []
    if piece.has_flag('closed'):
        for flag in ['blocking', 'blocks sight', 'closed']:
            if piece.has_flag(flag):
                flags.append(flag)
                piece.unset_flag(flag)
        interaction['flags'] = flags
        interaction['closed shape'] = piece.shape
        piece.shape = interaction['open shape']
        piece.name = piece.name.replace('closed', 'open')
        piece.set_flag('open')
        if agent.is_player():
            message("You open the door.")
            game.fov_recompute = True
        game.set_fov_at(piece.x, piece.y)
    elif piece.has_flag('open'):
        piece.unset_flag('open')
        piece.name = piece.name.replace('open', 'closed')
        for flag in interaction['flags']:
            piece.set_flag(flag)
        interaction['open shape'] = piece.shape
        piece.shape = interaction['closed shape']
        if agent.is_player():
            message("You close the door.")
            game.fov_recompute = True
        game.set_fov_at(piece.x, piece.y)
    else:
        raise Exception('Manipulating a door that does not have an open/closed flag.')
        


