'''
This code is part of NightmareTyrant; Copyright (C) 2013 Piotr 'ZasVid' Sikora; see NightmareTyrant.py for full notice.
'''

_trait_levels = { 'shields' : [(1, 'full')] ,
                  'health' : []
                }

_trait_desc = {'defense': ['Inferior', 'Competent', 'Superior'],
               'skill': ['Inferior', 'Competent', 'Superior'],
               'attitude' : ['Cautious', '' ,'Reckless'],
               'luck' : ['Unlucky', '' , 'Lucky'],
               'confidence' : ['Stressed', '' ,'Confident']
               }

_duration_description = {
            'permanent': '',
            'temporary': 'temporarily',
            'tactical' : 'tactically'
                    }
    
def duration_description(duration):
    return _duration_description[duration]

def trait_description(trait, trait_level):
    trait_level_mod = 1 if trait_level > 0 else 0 if trait_level == 0 else -1
    descriptor = _trait_desc[trait][1 + trait_level_mod]
    trait_level_magnitude = trait_level * trait_level_mod
    if trait_level_magnitude > 1:
        descriptor += '!'
    if trait_level_magnitude > 2:
        descriptor = descriptor.upper()
    prefix = "{0}: ".format(trait.capitalize()) if trait in ['defense', 'skill'] else ''
    return prefix + descriptor

def trait_level_description(trait, agent):
    current_value = agent[trait]
    max_value = agent["max " + trait]
    trait_ratio = float(current_value)/max_value
    if trait_ratio == 1:
        return "full " + trait
    elif trait_ratio > 0.75:
        return "nearly full " + trait
    elif trait_ratio > 0.5:
        return "still strong " + trait
    elif trait_ratio > 0.25:
        return "weakened " + trait
    else:
        return "waning " + trait
    
def health_description(health, max_health):
    pass
     