'''
This code is part of NightmareTyrant; Copyright (C) 2013 Piotr 'ZasVid' Sikora; see NightmareTyrant.py for full notice.
'''

#from guts.game_pieces import Terrain, Feature, Item
#from guts.game_agents import Agent, Player, item_action_types
#from guts.actions import new_action
from guts.debug import debug
from guts.game_quests import Objective, Quest

def prepare_quest(quest_name):
    quest = Quest(quest_name, quests[quest_name]['description'], quests[quest_name]['status'])
    for objective in quests[quest_name]['objectives']:
        obj_id = objective['id']
        obj_desc_todo = objective['desc_todo']
        obj_desc_done = objective['desc_done']
        obj_kind = objective['kind']
        obj_target = objective['target']
        prereqs = objective['prereqs'] if 'prereqs' in objective else []
        """ 
        if 'prereqs' in objective:
            for prereq_id in objective['prereqs']:
                prereqs.append(quest.get_goal(prereq_id))
        """
        repeats = objective['repeats'] if 'repeats' in objective else 1
        optional = objective['optional'] if 'optional' in objective else False 
        quest.add_goal(Objective(obj_id, obj_desc_todo, obj_desc_done, obj_kind, obj_target, prereqs, repeats, optional))
        
    return quest

quests = {'Cursed Forest': { 
            'description': 'Cursed Forest',
            'status': 'available', 
            'objectives': [{'id' : 'kill',
                            'desc_todo': 'Slay the evil witch, who cursed this place.',
                            'desc_done': 'You have slain the evil witch.',
                            'kind': 'KILL',
                            'target': 'the Witch'
                           }
                          ]
          },
          'Haunted Graveyard': { 
            'description': 'Haunted Graveyard',
            'status': 'available', 
            'objectives': [{'id' : 'kill',
                            'desc_todo': 'Slay the dread necromancer, who haunts this place.',
                            'desc_done': 'You have slain the dread necromancer.',
                            'kind': 'KILL',
                            'target': 'the Necromancer'
                           }
                          ]
          },
          'Rat-infested Landfill': { 
            'description': 'Rat-infested Landfill',
            'status': 'available', 
            'objectives': [{'id' : 'kill',
                            'desc_todo': 'Slay the outcast piper, who lured rats to this place.',
                            'desc_done': 'You have slain the outcast piper.',
                            'kind': 'KILL',
                            'target': 'the Piper'
                           }
                          ]
          },
          'Black Market': { 
            'description': 'Black Market',
            'status': 'available', 
            'objectives': [{'id' : 'kill',
                            'desc_todo': 'Slay the crime lord, who runs this place.',
                            'desc_done': 'You have slain the crime lord.',
                            'kind': 'KILL',
                            'target': 'the Crime Lord'
                           }
                          ]
          },
          'Nightmare World': { 
            'description': 'Nightmare World',
            'status': 'available', 
            'objectives': [{'id' : 'final',
                            'desc_todo': 'Slay the Nightmare Tyrant, who invaded the dreams of this town.',
                            'desc_done': 'You have slain the Nightmare Tyrant.',
                            'kind': 'KILL',
                            'target': 'the Nightmare Tyrant'
                           }
                          ]
          },
         }

def prepare_campaign(campaign_title):
    campaign_missions = []
    for mission_title in campaigns[campaign_title]:
        campaign_missions.append(prepare_quest(mission_title))
    return campaign_missions

campaigns = {'Nightmare Tyrant' : ['Haunted Graveyard', 'Cursed Forest', 'Rat-infested Landfill', 'Black Market', 'Nightmare World']
             }
