'''
This code is part of NightmareTyrant; Copyright (C) 2013 Piotr 'ZasVid' Sikora; see NightmareTyrant.py for full notice.
'''

import libtcodpy as libtcod
from debug import debug

default_color = libtcod.Color(0xff, 0x69, 0xb4) # hot pink ;)
default_shape = libtcod.CHAR_BLOCK3

shapes = {'space' : ' ', 'floor' : '.', 'water' : '~', 'wall' : '#', 'overgrown floor': ';',
          'window' : '-', 'cauldron': 'u',
          'nothing' : ' ',
          'terminal' : '&', 'rubble' : '%', 
          'closed door':'|', 'open door':':', 'ancient door':'|', 'wooden door':'|',
          'stairs down' : '>', 'stairs up' : '<', 'stairs next' : '>', 'stairs prev' : '<',
          'corpse' : '%',
          'player' : '@',
          'human' : '@', 'person' : '@',
          'throne' : '6',
          'tree' : '7', 'tombstone': '+', 'statue': '&', 'table': '=', 'star': '*',
          
          'zombie' : 'Z', 'bat' : 'b', 'skeleton' : 'S', 'ghost' : 'G', 'wisp': 'g',
          'criminal' : 'C', 'dog' : 'd',
          'swarm' : 'w', 'beastman': 'B',
          'ratling' : 'R', 'rat' : 'r',
          'unknown' : 'X', 'tyrant': 'T',
          'medical' : '+', 'ranged weapon' : '{', 'melee weapon' : '/', 'grenade' : '?',
          'n/a' : default_shape
          }
   
def _c(r,g,b):
    """ Shortening the notation. """
    return libtcod.Color(r,g,b) 
    
colors = {'n/a': default_color,
          'black': libtcod.black, 'white': libtcod.white, 'joke': default_color,
          'gold':  _c(255, 0xD7, 0), 'gray': _c(128,128,128),
          'player': libtcod.gold,
          'ui' : _c(94,32,112), 'ui text' : _c(170,194,112),
          'dark nightmare': _c(94,32,112), 'light nightmare': _c(170,194,112),
          'completed quest': libtcod.lightest_amber, 'tracked quest': libtcod.light_amber, 'optional quest': libtcod.lighter_amber,
          #fallout rl colours
          'normal_text': _c(60, 248, 0), 'warning_text': _c(155, 41, 37), 'highlighted_text': _c(245, 243, 168), 'faded_text': _c(29, 46, 27),
          'green' : libtcod.green,
          #TODO: name colors:
          'frag' : libtcod.light_orange, 'failure': libtcod.magenta, 'confusion': libtcod.light_green, 'clarity' : libtcod.light_cyan,
          
          'special equipment': libtcod.light_sepia,
          
          'dirty brown' : libtcod.sepia,
          'inky black': libtcod.darkest_blue,
          'dusty gray': libtcod.gray,
          'grave grey': libtcod.dark_grey,
          'bone white': libtcod.lightest_gray,
          'deathly white' : libtcod.white,
          'cursed yellow': libtcod.dark_yellow,
          'dark wooden' : libtcod.dark_sepia,
          'wooden' : libtcod.sepia,
          'copper' : _c(193, 114, 73),
          'light watery' : _c(172, 220, 218),  
          'sandy': _c(223, 203, 141),
          'fashionable' : libtcod.light_purple,
          'mellow' : _c(172, 216, 180),
          'angry': _c(255, 0, 0),
          'fiery': _c(255, 127, 0),
          
          
          'Haunted Graveyard': libtcod.dark_grey, #same as grave grey
          'Cursed Forest': libtcod.dark_green,
          'Rat-infested Landfill': libtcod.sepia, #dirty brown
          'Black Market': _c(193, 114, 73), # copper
          'Nightmare World' : _c(94,32,112), #same as 'dark nightmare'
          
          
          #TODO: legacy colors:
          'electric': libtcod.light_cyan,
          'metallic green' : _c(161,203,121), 'metallic gray' : _c(162,162,162), 'metallic' : _c(162,162,162),
          'shields': libtcod.blue,'full shields' : _c(155,195,255), 'nearly full shields' : _c(115,155,225), 'still strong shields'  : _c(75,115,195), 'weakened shields' : _c(35,75,165), 'waning shields' : libtcod.darker_blue,
          'health': libtcod.red,'full health' : _c(255,225,225), 'nearly full health' : _c(255,180,180), 'still strong health'  : _c(255,120,120), 'weakened health' : _c(255,60,60), 'waning health' : _c(255,0,0),

          
          'positive': libtcod.light_green, 'warning': libtcod.orange, 'negative': libtcod.red,
          'out of sight' : libtcod.darker_gray,
          'important' : libtcod.light_yellow,
          
          'objective fulfilled': libtcod.gold, 'objective available': libtcod.white, 'objective unavailable': libtcod.gray, 
          'quest ': libtcod.pink,
          
          'hot pink' :  libtcod.Color(0xff, 0x69, 0xb4),
          'blood red': libtcod.darker_red, 
          'stamina': libtcod.green, 'dying green': libtcod.dark_green,
          'health': libtcod.red,'full health' : _c(255,225,225), 'nearly full health' : _c(255,180,180), 'still strong health'  : _c(255,120,120), 'weakened health' : _c(255,60,60), 'waning health' : _c(255,0,0),
          'damage' : libtcod.dark_red,
          'fatigue' : libtcod.dark_green,
          'caution' : _c(172, 216, 180), 
          'attitude': _c(255, 0, 0),
          'jinx' : libtcod.darker_yellow,
          'luck': libtcod.light_yellow,
          'imbalance': libtcod.dark_blue, 
          'defense': _c(70, 130, 180),
          'stress': libtcod.dark_purple,
          'confidence': libtcod.lighter_purple,
          'disability' : libtcod.dark_turquoise, 
          'skill': libtcod.light_turquoise,
          'loss of items' : libtcod.dark_sepia
          
          }

def shape(shape_name):
    if shape_name not in shapes:
        debug.log("Missing shape: " + shape_name)
    return shapes.get(shape_name, default_shape)

def color(color_name):
    if color_name not in colors:
        debug.log("Missing color: "+color_name)
        return default_color
    return colors[color_name]
